<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\OrdemServService;
use FM\Traits\TResponse;

class OrdemServController
{
    use TResponse;
    protected $OrdemServService;

    public function __construct(OrdemServService $OrdemServService)
    {
        $this->OrdemServService = $OrdemServService;
    }

    public function ordemServ(DTO\Request $request, DTO\Response $response)
    {
        $response->addDataSet(new DataSet('ordens', $this->OrdemServService->getOrdemServ(($request->getParameters())['NR'])));
    }

    public function getOrdensServicoParaDashboard(DTO\Request $request, DTO\Response $response)
    {
        try {
            $data = $this->OrdemServService->getOrdensServicoParaDashboard();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getOrdensServicoDash(Request $request)
    {
        try {
            $data = $this->OrdemServService->getOrdensServicoDash();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getOrdensPendentes(DTO\Request $request, DTO\Response $response)
    {
        try {
            $data = $this->OrdemServService->getOrdensPendentes();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
