<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use FM\Service\OrdensServicoService;
use FM\Traits\TResponse;

class OrdensServicoController
{

    use TResponse;

    protected $OrdensServicoService;

    public function __construct($OrdensServicoService)
    {
        $this->OrdensServicoService = $OrdensServicoService;
    }

    public function getOrdensServico(Request $request)
    {
        try {
            $data = $this->OrdensServicoService->getOrdensServico($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getImagensOrdemServ(Request $request)
    {
        try {
            $data = $this->OrdensServicoService->getImagensOrdemServ($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function finalizarOS(Request $request)
    {
        try {
            $data = $this->OrdensServicoService->finalizarOS($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function recusarOS(Request $request)
    {
        try {
            $data = $this->OrdensServicoService->recusarOS($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function pausarOS(Request $request)
    {
        try {
            $data = $this->OrdensServicoService->pausarOS($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function iniciarOS(Request $request)
    {
        try {
            $data = $this->OrdensServicoService->iniciarOS($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getModeloPopOrdemServ(Request $request)
    {
        try {
            $data = $this->OrdensServicoService->getModeloPopOrdemServ($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAnexoModeloPopOrdemServ(Request $request)
    {
        try {
            $data = $this->OrdensServicoService->getAnexoModeloPopOrdemServ($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getEpisOS(Request $request)
    {
        try {
            $data = $this->OrdensServicoService->getEpisOS($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}