<?php

namespace FM\Service;

use FM\Factory\QrCodeFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Endroid\QrCode\QrCode;

class QrCodeService
{

    protected $connection;
    protected $QrCodeFactory;
    protected $Environment;
    protected $newCode;

    public function __construct(EntityManager $entityManager, Environment $Environment, NewCode $newCode, QrCodeFactory $QrCodeFactory)
    {
        $this->connection = $entityManager->getConnection();
        $this->Environment = $Environment;
        $this->newCode = $newCode;
        $this->QrCodeFactory = $QrCodeFactory;
    }

    public function buscaTarefasPorOperador($param)
    {
        $params = implode(',', $param);
        $resposta = $this->QrCodeFactory->buscaTarefasPorOperador($params);
        return $this->validaOperador($resposta, $param);
    }

    public function validaOperador($resposta, $param)
    {
        $cdOperadorPai = array();
        $cdOperador = array();

        foreach ($resposta as $row) {
            if (!empty($row['CDOPERADORPAI']) && !in_array($row['CDOPERADORPAI'], $cdOperadorPai)) {
                $cdOperadorPai[] = $row['CDOPERADORPAI'];
            }
            if (!empty($row['CDOPERADOR']) && !in_array($row['CDOPERADOR'], $cdOperador)) {
                $cdOperador[] = $row['CDOPERADOR'];
            }
        }

        $dados = [
            'PAI' => [],
            'FILHO' => []
        ];

        if (in_array($param["CDOPERADOR"], $cdOperadorPai)) {
            $dados['PAI'] = $this->QrCodeFactory->findVistoria($param, '');
        }

        if (in_array($param["CDOPERADOR"], $cdOperador)) {
            $dados['FILHO'] = $this->QrCodeFactory->findTarefa($param, '');
        }

        return $dados;
    }
}
